/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008, 2009. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("jazz.ui.tree.LinkItem");

dojo.require("dijit._Templated");
dojo.require("jazz.ui.tree.AbstractItem");

(function() {

dojo.declare("jazz.ui.tree.LinkItem", [jazz.ui.tree.AbstractItem, dijit._Templated], {
	// summary:
	//		A subclass of jazz.ui.tree.AbstractItem that shows a link in the tree.
	//
	//      NOTE: This is provisional API. Clients using this API do so with the
	//		awareness that this class may be removed or substantially changed at
	//		future times without warning.
	// description:
	//		One of 'href' or 'onclick' is required.
	// since:
	//		0.7
	
	label:"",	// The label for the link
	href:"",	// The href the link should point at
	onclick:"",	// The onclick handler for the link
	
	templateString: "<a dojoAttachPoint='_link'></a>",
	
	init: function() {
		this.update();
	},
	
	update: function() {
		if (this.onclick && !this.handler)
			this.handler = this.connect(this._link,"onclick",this.onclick);
		this._link.href = this.href;
		this._link.innerHTML = "";
		this._link.appendChild(document.createTextNode(this.label));
	},
	
	getFocusNode: function() {
		return this._link;
	}
	
});

})();