/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005-2008. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
(function() {
dojo.provide("net.jazz.ajax.service.ui.internal.login.LoginLogoutArea");

dojo.require("dojo.cookie");

dojo.require("jazz.client.xhr");

// constants
var COOKIE_USER_ID = "net-jazz-ajax-cookie-userName";
var EVENT_LOGIN = "net.jazz.ajax.events.login";
var EVENT_LOGOUT = "net.jazz.ajax.events.logout";
var URL_LOGIN = "/_session/login";
var URL_LOGOUT = "/_session/logout";

dojo.declare("net.jazz.ajax.service.ui.internal.login.LoginLogoutArea", dijit._Widget, {

	create: function(args, srcNodeRef) {
		if(!srcNodeRef) {
			srcNodeRef = document.createElement("span");
		}
		this.message = document.createElement("span");
		this.message.id = "com-ibm-team-foundation-web-userNameMsg";
		srcNodeRef.appendChild(this.message);
		this.link = document.createElement("a");
		srcNodeRef.appendChild(this.link);
		this.inherited(arguments);
		dojo.subscribe(EVENT_LOGIN, this, "_setLoggedIn");
		dojo.subscribe(EVENT_LOGOUT, this, "_setLoggedOut");
	},
	
	postCreate: function() {
		if(dojo.cookie(COOKIE_USER_ID)) {
			this._setLoggedIn();
		} else {
			this._setLoggedOut();
		}
		this.connect(this.link, "onclick", "_onClick");
	},
	
	_onClick: function(e) {
		dojo.stopEvent(e);
		var mode = this.link.href.indexOf("login") === -1 ?
			"logout" : "login";
		this._doAction(mode);
	},
			load: function() {
				self._setMode(mode === "login" ? "logout" : "login");
				
			},
	
	_doAction: function(mode) {
		var self = this;
		var dfd = jazz.client.xhrPost({
			url: mode === "logout" ? URL_LOGOUT : URL_LOGIN,
			error: function(err) {
				console.error("Error " + (mode === "logout" ? "Logging out" : "Logging in"));
			}
		});
	},
	
	_setLoggedIn: function() {
		this._setMode("logout");
	},
	
	_setLoggedOut: function() {
		this._setMode("login");
	},
	
	_setMode: function(/*String*/mode) {
		if(mode !== "login" && mode !== "logout") {
			throw new Error("Invalid mode: " + mode);
		}
		if(mode === "login") {
			this.link.innerHTML = "Log In";
			this.link.href = URL_LOGIN;
			this.message.style.display = "none";
		} else {
			this.link.innerHTML = "Log Out";
			this.link.href = URL_LOGOUT;
			this.message.style.display = "";
			this.message.innerHTML = "";
			if(dojo.cookie(COOKIE_USER_ID)) {
				this.message.appendChild(document.createTextNode("Logged in as: " + dojo.cookie(COOKIE_USER_ID)));
			};
		}
		this.link.innerHTML = mode === "login" ? "Log In" : "Log Out";
		this.link.href = mode === "login" ? URL_LOGIN : URL_LOGOUT;
	}
	
});

})();