/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
(function(){
    dojo.provide("net.jazz.ajax.service.ui.userdata.FavoriteWidget");
    
    dojo.require("dojo.cookie");
    
    dojo.require("dijit._Widget");
    dojo.require("dijit._Templated");
    
    dojo.require("dojox.data.dom");
    dojo.require("net.jazz.ajax.service.ui.userdata.util");
    
    // constants
    var COOKIE_USER_ID = "net-jazz-ajax-cookie-userName";
	var EVENT_LOGIN = "net.jazz.ajax.events.login";
	var EVENT_LOGOUT = "net.jazz.ajax.events.logout";
    
    var Util = net.jazz.ajax.service.ui.userdata.util;
    
    function getLoggedInUser(){
        return dojo.cookie(COOKIE_USER_ID);
    }
    
    dojo.declare("net.jazz.ajax.service.ui.userdata.FavoriteWidget", [dijit._Widget, dijit._Templated], {
    
        templateString: "<div><div class=\"net-jazz-ajax-service-ui-userdata-FavoriteWidget\"><div dojoAttachPoint=\"favImg\"></div></div></div>",
        
        constructor: function(args){
            this.url = args.url
        },
        
        postCreate: function(){
            this.inherited(arguments);
            this.updateState();
            dojo.subscribe(EVENT_LOGIN, dojo.hitch(this, this.updateState));
            dojo.subscribe(EVENT_LOGOUT, dojo.hitch(this, this.updateState));
			dojo.connect(this.favImg, "onclick", dojo.hitch(this, function (e) {
				if (this.isFavorite) {
					Util.removeFavorites([this.url]);
					this.setStatus(false);
				}
				else {
					Util.addFavorite({
						uri: this.url
					});
					this.setStatus(true);
				}
			}));
        },
        
        updateState: function(){
            var loggedInUser = getLoggedInUser();
            if (loggedInUser) {
                dojo.toggleClass(this.favImg, "hidden", false);
                var dfd = Util.isFavorite(this.url);
                dfd.addCallback(dojo.hitch(this, function(resp){
					this.setStatus(resp);
                }));
                dfd.addErrback(dojo.hitch(this, function(resp){
                    this.setStatus(false);
                }))
            }
            else {
                dojo.toggleClass(this.favImg, "hidden", true);
            }
        },
        
        setStatus: function(isFavorite){
            this.isFavorite = isFavorite;
            if (isFavorite) {
                dojo.toggleClass(this.favImg, "favorite", true);
				this.favImg.title = "Remove favorite";
            }
            else {
                dojo.toggleClass(this.favImg, "favorite", false);
				this.favImg.title = "Add favorite";
            }
        }
    });
    
})();
